<?php

    # load FlexPay library
    require "../../../init.php";
    $whmcs->load_function( "gateway" );
    $whmcs->load_function( "invoice" );
    require_once ROOTDIR . '/modules/gateways/verotelflexpay/FlexPay.php';

    $gatewaymodule = "verotelflexpay";
    $GATEWAY = getGatewayVariables( $gatewaymodule );
    if (!$GATEWAY["type"]) exit( "Module Not Activated" );

    function check_signature( $gateway, $params ){
        if( !FlexPay::validate_signature( $gateway["flexpay_secret"], $params )){
            logTransaction( $gateway["name"], $params, "Invalid signature" );
            exit( 'Invalid signature' );
        }
    }

    function record_approved_sale( $gateway, $invoice_id, $sale_id ){
        if (!is_sale_already_recorded( $sale_id )){
            addInvoicePayment( $invoice_id, $sale_id, "", "", $gateway["name"] );
            logTransaction( $gateway["name"], $_GET, "Successful" );
        }
    }

    function is_sale_already_recorded( $sale_id ){
        $result = select_query( "tblaccounts", "invoiceid", array( "transid" => $sale_id ) );
        $data = mysql_fetch_array( $result );

        return $data["invoiceid"];
    }

    function render_success_page_ok( $invoice_id ){
		header( "Location: ../../../viewinvoice.php?id=" . $invoice_id . "&paymentsuccess=true" );
		exit();
    }

    function render_callback_ok(){
        print( 'OK' );
    }

    check_signature( $GATEWAY, $_GET );

    $invoice_id = checkCbInvoiceID($_GET["referenceID"], $GATEWAY["name"]);

    record_approved_sale( $GATEWAY, $invoice_id, $_GET["saleID"] );

    if ($_GET["callback"]){
        render_callback_ok();
    }else{
        render_success_page_ok( $invoice_id );
    }
?>
